unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    StaticText2: TStaticText;
    Button2: TButton;
    Label1: TLabel;
    Label5: TLabel;
    StaticText1: TStaticText;
    Label2: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var A,N,S : dword;

function RecROOT(i : byte) : double;
//recursive root
begin
 if i > 1 then result := A + S/(A + RecROOT(i-1))
  else result := A + S/(2*A);
end;

procedure TForm1.Button2Click(Sender: TObject);
//calculate root recursive way
const fs = '#0.0####';
var i,c  : byte;
    root : double;
begin
 try
  N := strtoint(edit1.text);
 except
  N := 1;
  edit1.Text := '1';
 end;
 c := 0;
 if N > 0 then
  begin
   for i := 0 to 31 do
    if ((1 shl i) and N) <> 0 then c := i;
   c := c shr 1;  //2 bit multiple
   A := 1 shl c;  //largest single bit root
   S := N - (A shl c);
   root := RecROOT(10);  //depth = 10
  end
  else root := 0;
 statictext2.Caption := FormatFloat(fs,root);
 statictext1.caption := formatfloat(fs,sqrt(N));
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
//character filter 
begin
 if not (key in ['0'..'9',#08]) then key := #0;
end;

end.
